import numpy as np
from sklearn.datasets import load_breast_cancer
from sklearn.model_selection import train_test_split
from sklearn.ensemble import RandomForestClassifier
import matplotlib.pyplot as plt

cancer = load_breast_cancer( )

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split(
   cancer.data, cancer.target, stratify=cancer.target, random_state = 40 )

arbol = RandomForestClassifier( max_depth=3, n_estimators=20, random_state=15 )

arbol.fit( X_entrena, y_entrena )

print( "Precisiones" )
print( "En el entrenamiento:", arbol.score( X_entrena, y_entrena ) ) 
print( "En la prueba       :", arbol.score( X_prueba, y_prueba ) )

fig, ax = plt.subplots( )

def plot_features_importances( model ) :
	n_features = cancer.data.shape[1]
	ax.barh( np.arange( n_features), model.feature_importances_, align='center' )

	plt.yticks( np.arange(n_features), cancer.feature_names )
	ax.set_xlabel( "Importance de las características" )
	ax.set_ylabel( "Características" )


plot_features_importances( arbol )

plt.show( )
            
